#include "player.h"
#include <gint/defs/util.h>

static int xp_to_next_level(int level)
{
    return 3 * (level + 2) * (level + 2);
}

bool player_add_xp(player_t *p, int points)
{
    bool leveled_up = false;
    p->xp_current += max(points, 0);

    while(p->xp_current >= p->xp_to_next_level) {
        p->xp_current -= p->xp_to_next_level;
        p->xp_level++;
        p->xp_to_next_level = xp_to_next_level(p->xp_level);
        leveled_up = true;
    }

    /* Recompute statistics */
    if(leveled_up) {
        fighter_t *f = getcomp(p->entity, fighter);
        int previous_HP_max = f->HP_max;
        fighter_set_stats(getcomp(p->entity, fighter), &p->stat_model,
            p->xp_level, fix(2.0));
        f->HP += (f->HP_max - previous_HP_max);
    }

    return leveled_up;
}
